#Dans Terminal:
#jupyter lab
#python tp1.py


import matplotlib.pyplot as plt
import numpy as np

def jac(A):
    D=np.diag(np.diag(A))
    E=-np.tril(A-D)
    F=-np.triu(A-D)
    return D,E+F

def jac_rel(A,om):
    D=np.diag(np.diag(A))
    M=D/om
    E=-np.tril(A-D)
    F=-np.triu(A-D)
    N=E+F+(1-om)*M
    return M,N


def spline(n):
   # A=4*np.diag(np.ones(n))-np.diag(np.ones(n-1),-1)-np.diag(np.ones(n-1),+1)
    return 4*np.diag(np.ones(n))+np.diag(np.ones(n-1),-1)+np.diag(np.ones(n-1),+1)

def lapl(n):
    return 2*np.diag(np.ones(n))-np.diag(np.ones(n-1),-1)-np.diag(np.ones(n-1),+1)
    
    
def iterativ_(M,N,b):
    [u,v]=np.shape(M)
    #x0=np.zeros([u,1])
    x0=np.random.rand(u,1)
    itmax=400 #200 #100 #20 #10
    x=x0
    for i in range(itmax):
        x=np.linalg.solve(M,np.dot(N,x)+b)
    return x

def iterativ(M,N,b,eps):
    [u,v]=np.shape(M)
    #x0=np.zeros([u,1])
    x0=np.random.rand(u,1)
    itmax=400 #200 #100 #20 #10
    x=x0
    i=0
    compt=np.zeros(itmax+1)
    compt[0]=1
    crit=1
    err=np.zeros(itmax+1)
    err[0]=1
    while (i<itmax) and (crit>eps):
    #for i in range(itmax):
        x=np.linalg.solve(M,np.dot(N,x)+b)
        i=i+1
        compt[i]=i
        crit=np.linalg.norm(x-np.ones([u,1]))
        err[i]=crit
    return x,err[:i],compt[:i]

def rho_lap(n): # rayon spectral de la matrice de Jacobi
    return np.cos(np.pi/(n+1))

def rho_spline(n): # rayon spectral de la matrice de Jacobi
    return 0.5*np.cos(np.pi/(n+1))

    

    
    
#1 (b)

dim=15

# Matrice Spline

A=spline(dim)
#A=lapl(dim)
#print(A)

b=np.dot(A,np.ones([dim,1]))

M,N=jac(A)

    
eps=1e-3    
x,err,compt=iterativ(M,N,b,eps)
#print(x)
errfin=np.linalg.norm(x-np.ones([dim,1]))
#print(errfin)
print('Cas de la matrice Spline:')
print('La méthode converge en ', np.size(err), 'pas')

plt.plot(compt,np.log(err))
plt.title('Erreur pour la matrice Spline')

P=np.polyfit(compt,np.log(err),1)
#chaine='pente'+str(round(P[0],2))
#plt.text(100,0.001,chaine)
plt.show()

rho_exp=np.exp(round(P[0],2))
#print('rho =',rho_exp)
# print('rho =',np.exp(round(P[0],2)))

verif=np.abs(rho_spline(dim)-rho_exp)        
#np.abs(rho(iterjac(A))-rho_exp)
#print('à',verif, 'près')

print('rho =',rho_exp,'à',verif, 'près')

# Matrice du Laplacien

#A=spline(dim)
A=lapl(dim)
#print(A)

b=np.dot(A,np.ones([dim,1]))

M,N=jac(A)
    
eps=1e-3    
x,err,compt=iterativ(M,N,b,eps)
#print(x)
errfin=np.linalg.norm(x-np.ones([dim,1]))
#print(errfin)
print('Cas de la matrice du Laplacien:')
print('La méthode converge en ', np.size(err), 'pas')

plt.plot(compt,np.log(err))
plt.title('Erreur pour la matrice du Laplacien')

P=np.polyfit(compt,np.log(err),1)
#chaine='pente'+str(round(P[0],2))
#plt.text(100,0.001,chaine)
plt.show()


#print('rho =',np.exp(round(P[0],2)))

rho_exp=np.exp(round(P[0],2))
#print('rho =',rho_exp)
# print('rho =',np.exp(round(P[0],2)))

verif=np.abs(rho_lap(dim)-rho_exp)
#np.abs(rho(iterjac(A))-rho_exp)
#print('à ',verif,' près')

print('rho =',rho_exp,'à',verif, 'près')