#Dans Terminal:
#jupyter lab
#python tp1.py


import matplotlib.pyplot as plt
import numpy as np

def jac(A):
    D=np.diag(np.diag(A))
    E=-np.tril(A-D)
    F=-np.triu(A-D)
    return D,E+F

def jac_rel(A,om):
    D=np.diag(np.diag(A))
    M=D/om
    E=-np.tril(A-D)
    F=-np.triu(A-D)
    N=E+F+(1-om)*M
    return M,N


def spline(n):
    return 4*np.diag(np.ones(n))+np.diag(np.ones(n-1),-1)+np.diag(np.ones(n-1),+1)

def lapl(n):
    return 2*np.diag(np.ones(n))-np.diag(np.ones(n-1),-1)-np.diag(np.ones(n-1),+1)
    
    

def iterativ_(M,N,b,eps):
    [u,v]=np.shape(M)
    #x0=np.zeros([u,1])
    x0=np.random.rand(u,1)
    itmax=400 #200 #100 #20 #10
    x=x0
    i=0
    compt=np.zeros(itmax+1)
    compt[0]=1
    crit=1
    err=np.zeros(itmax+1)
    err[0]=1
    while (i<itmax) and (crit>eps):
    #for i in range(itmax):
        x=np.linalg.solve(M,np.dot(N,x)+b)
        i=i+1
        compt[i]=i
        crit=np.linalg.norm(x-np.ones([u,1]))
        err[i]=crit
    return x,err[:i],compt[:i]

def iterativ(M,N,b,eps,sol):
    [u,v]=np.shape(M)
    #x0=np.zeros([u,1])
    x0=np.random.rand(u,1)
    itmax=400 #200 #100 #20 #10
    x=x0
    i=0
    compt=np.zeros(itmax+1)
    compt[0]=1
    crit=1
    err=np.zeros(itmax+1)
    err[0]=1
    while (i<itmax) and (crit>eps):
    #for i in range(itmax):
        x=np.linalg.solve(M,np.dot(N,x)+b)
        i=i+1
        compt[i]=i
        crit=np.linalg.norm(x-sol)
        err[i]=crit
    return x,err[:i],compt[:i]


def rho_lap_rel(n,om):
    return max(om-1+om*np.cos(np.pi/(n+1)),1-om+om*np.cos(np.pi/(n+1)))


def rho_spline_rel(n,om):
    #return max(np.abs(1-om*np.cos(np.pi/(n+1))/8),np.abs(1+om*np.cos(np.pi/(n+1))/8))
    return max(-1+om+0.5*np.cos(np.pi/(n+1)),1-om+0.5*np.cos(np.pi/(n+1)))

def rho_lap(n):
    return np.cos(np.pi/(n+1))

def rho_spline(n):
    return 0.5*np.cos(np.pi/(n+1))

    
    
#1 (c)

#om=1.125 # 1.25 # 0.75 # 1.5 # 2
# 0.001 # 0.01 # 0.1 # 0.25 # 0.5 # 1
dim=15 #40 #20 # 3 #5 #10 # 15
eps=1e-3
pas=100



om=1
tab_rhoj_sp=np.zeros(6)
tab_verif_sp=np.zeros(6)
tab_vit=np.zeros(6)
tab_dim=np.zeros(6)

i=0
for dim in np.array([3,5,10,15,20,40]):
    
    tab_dim[i]=dim
    #tab_rhoj_sp[i]=rho_spline(dim)
    #rhoj_sp(dim)
    A=spline(dim)
    verif=rho_spline(dim)
    #rho(iterjac(A))
    tab_verif_sp[i]=verif
    
    #tab_vit=np.zeros(pas)
    
    for k in range(5): 
        sol=np.random.rand(dim,1)
        sol=sol/np.linalg.norm(sol)
        b=np.dot(A,sol)
        
        M,N=jac(A)
        x,err,compt=iterativ(M,N,b,eps,sol)
        P=np.polyfit(compt,np.log(err),1)
        rho_exp=np.exp(round(P[0],2))
        tab_vit[i]=max(rho_exp,tab_vit[i])
    i=i+1
    
plt.plot(tab_dim,tab_vit)
plt.title('Vitesse pour les matrices  Spline et Laplacien')
#plt.show()
                             
# Matrice du Laplacien

tab_rhoj=np.zeros(6)
tab_verif_lap=np.zeros(6)
tab_vitl=np.zeros(6)
tab_dim=np.zeros(6)

i=0
for dim in np.array([3,5,10,15,20,40]):
    
    tab_dim[i]=dim
    #tab_rhoj[i]=rho_lap(dim)
    #rhoj(1,dim)
    A=lapl(dim)
    verif=rho_lap(dim)
    #rho(iterjac(A))
    tab_verif_lap[i]=verif
    
    #tab_vit=np.zeros(pas)
    
    for k in range(5): 
        sol=np.random.rand(dim,1)
        sol=sol/np.linalg.norm(sol)
        b=np.dot(A,sol)
        
        M,N=jac(A)
        x,err,compt=iterativ(M,N,b,eps,sol)
        P=np.polyfit(compt,np.log(err),1)
        rho_exp=np.exp(round(P[0],2))
        tab_vitl[i]=max(rho_exp,tab_vitl[i])
    i=i+1
    
plt.plot(tab_dim,tab_vitl)
#plt.title('Vitesse pour la matrice  du Laplacien')
plt.show()


plt.plot(tab_dim,tab_vit)
plt.plot(tab_dim,tab_verif_sp)
#plt.plot(tab_dim,tab_rhoj_sp)
plt.title('Vitesse pour la matrice Spline')
plt.show()


plt.plot(tab_dim,tab_vitl)
plt.plot(tab_dim,tab_verif_lap)
#plt.plot(tab_dim,tab_rhoj)
plt.title('Vitesse pour la matrice  du Laplacien')
plt.show()

#Pour la précision eps  et le nombre de pas k:
#rho<exp(ln(eps))/k
# avec rho=cos(pi/(N+1)) pour la matrice du Laplacien
#      rho=0.5*abs(cos(pi/(N+1))) pour la matrice des Splines