#Dans Terminal:
#jupyter lab
#python tp1.py


import matplotlib.pyplot as plt
import numpy as np


def jac(A):
    D=np.diag(np.diag(A))
    E=-np.tril(A-D)
    F=-np.triu(A-D)
    return D,E+F

def gs(A):
    D=np.diag(np.diag(A))
    E=-np.tril(A-D)
    F=-np.triu(A-D)
    return D-E,F


def jac_rel(A,om):
    D=np.diag(np.diag(A))
    M=D/om
    E=-np.tril(A-D)
    F=-np.triu(A-D)
    N=E+F+(1-om)*M
    return M,N

def gs_rel(A,om):
    D=np.diag(np.diag(A))
    E=-np.tril(A-D)
    #F=-np.triu(A-D)
    M=D/om-E
    return M,M-A



def spline(n):
    return 4*np.diag(np.ones(n))+np.diag(np.ones(n-1),-1)+np.diag(np.ones(n-1),+1)

def lapl(n):
    return 2*np.diag(np.ones(n))-np.diag(np.ones(n-1),-1)-np.diag(np.ones(n-1),+1)
    
    
def iterativ_(M,N,b,eps):
    [u,v]=np.shape(M)
    #x0=np.zeros([u,1])
    x0=np.random.rand(u,1)
    itmax=400 #200 #100 #20 #10
    x=x0
    i=0
    compt=np.zeros(itmax+1)
    compt[0]=1
    crit=1
    err=np.zeros(itmax+1)
    err[0]=1
    while (i<itmax) and (crit>eps):
    #for i in range(itmax):
        x=np.linalg.solve(M,np.dot(N,x)+b)
        i=i+1
        compt[i]=i
        crit=np.linalg.norm(x-np.ones([u,1]))
        err[i]=crit
    return x,err[:i],compt[:i]

def iterativ(M,N,b,eps,sol):
    [u,v]=np.shape(M)
    #x0=np.zeros([u,1])
    x0=np.random.rand(u,1)
    itmax=400 #200 #100 #20 #10
    x=x0
    i=0
    compt=np.zeros(itmax+1)
    compt[0]=1
    crit=1
    err=np.zeros(itmax+1)
    err[0]=1
    while (i<itmax) and (crit>eps):
    #for i in range(itmax):
        x=np.linalg.solve(M,np.dot(N,x)+b)
        i=i+1
        compt[i]=i
        crit=np.linalg.norm(x-sol)
        err[i]=crit
    return x,err[:i],compt[:i]


def rho_iter(M,N):
    return max(np.abs(np.linalg.eigvals(np.dot(np.linalg.inv(M),N))))
    

#1 (d)

#om=1.125 # 1.25 # 0.75 # 1.5 # 2
# 0.001 # 0.01 # 0.1 # 0.25 # 0.5 # 1
dim=15
eps=1e-3
pas=100



A=spline(dim)

tab_vit=np.zeros(pas)

for k in range(5):   #np.arange(5):
    sol=np.random.rand(dim,1)
    sol=sol/np.linalg.norm(sol)



# Matrice Spline

      
    
#A=lapl(dim)
#print(A)

          
    b=np.dot(A,sol)
    tab_rho=np.zeros(pas)
    tab_om=np.zeros(pas)
    tab_verif=np.zeros(pas)

    i=0



    for om in np.linspace(0.001,1.25,pas):
        tab_om[i]=om
        M,N=gs_rel(A,om)
        x,err,compt=iterativ(M,N,b,eps,sol)
         
            
        P=np.polyfit(compt,np.log(err),1)
        rho_exp=np.exp(round(P[0],2))
        tab_rho[i]=rho_exp
        tab_vit[i]=max(rho_exp,tab_vit[i])
        tab_verif[i]=rho_iter(M,N) 
        i=i+1

    
   
    plt.plot(tab_om,tab_rho)
    plt.plot(tab_om,tab_verif)
        
    plt.title('Matrice Spline: Rho en fonction de  omega')


    

plt.show()

#tab_verif=np.zeros(pas)
    

plt.title('Vitesse pour la matrice  Spline')
plt.plot(tab_om,tab_vit)
plt.plot(tab_om,tab_verif)
plt.show()
                             
# Matrice du Laplacien


A=lapl(dim)

tab_vit=np.zeros(pas)

for k in range(5):   #np.arange(5):
    sol=np.random.rand(dim,1)
    sol=sol/np.linalg.norm(sol)



    b=np.dot(A,sol)
    tab_rho=np.zeros(pas)
    tab_om=np.zeros(pas)
    tab_verif=np.zeros(pas)

    i=0



    for om in np.linspace(0.001,1.25,pas):
        tab_om[i]=om
        M,N=gs_rel(A,om)
        x,err,compt=iterativ(M,N,b,eps,sol)
         
            
        P=np.polyfit(compt,np.log(err),1)
        rho_exp=np.exp(round(P[0],2))
        tab_rho[i]=rho_exp
        tab_vit[i]=max(rho_exp,tab_vit[i])
        tab_verif[i]=rho_iter(M,N) #verif/rho_exp
        i=i+1

    
   
    plt.plot(tab_om,tab_rho)
    plt.plot(tab_om,tab_verif)
        
    plt.title('Matrice Spline: Rho en fonction de  omega')


    

plt.show()

#tab_verif=np.zeros(pas)
    

plt.title('Vitesse pour la matrice  du Laplacien')
plt.plot(tab_om,tab_vit)
plt.plot(tab_om,tab_verif)
plt.show()
                             
